/*************************************************
* Default Mutex Source File                      *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/mux_def.h>
#include <opencl/exceptn.h>

namespace OpenCL {

/*************************************************
* Lock the Mutex                                 *
*************************************************/
void Default_Mutex::lock()
   {
   if(locked)
      throw Internal_Error("Default_Mutex::lock: Mutex is already locked");
   locked = true;
   }

/*************************************************
* Unlock the Mutex                               *
*************************************************/
void Default_Mutex::unlock()
   {
   if(!locked)
      throw Internal_Error("Default_Mutex::unlock: Mutex is already unlocked");
   locked = false;
   }

/*************************************************
* Default_Mutex Constructor                      *
*************************************************/
Default_Mutex::Default_Mutex()
   {
   locked = false;
   }

}
